searchNodes=[{"doc":"The rate at which a video file frames are played back, measured in frames-per-second (24/1 = 24 frames-per-second). For more on framerate and why Vtc chooses to represent it as a rational number, see NTSC: Framerate vs timebase and The Rational Rationale Struct Fields playback : The rational representation of the real-world playback speed as a fraction in frames-per-second. ntsc : Atom representing which, if any, NTSC convention this framerate adheres to.","ref":"Vtc.Framerate.html","title":"Vtc.Framerate","type":"module"},{"doc":"Creates a new Framerate with a playback speed or timebase. Arguments rate : Either the playback rate or timebase. For NTSC framerates, the value will be rounded to the nearest correct value. Options ntsc : Atom representing the which (or whether an) NTSC standard is being used. Default: :non-drop . invert? : If true , the resulting rational rate value will be flipped so that 1/24 becomes 24/1 . This can be helpeful when you are parsing a rate given in seconds-per-frame rather than frames-per-second. Default: false . coerce_ntsc? : If true -- and ntsc is non-nil -- values will be coerced to the nearest valid NTSC rate. So 24 would be coerced to 24000/1001 , as would 23.98 . This option must be set to true when ntsc is non-nil and a float is passed. Default: false Float Precision Only floats representing a whole number can be passed for non-NTSC rates, as there is no fully precise way to convert fractional floats to rational values.","ref":"Vtc.Framerate.html#new/2","title":"Vtc.Framerate.new/2","type":"function"},{"doc":"As new/2 but raises an error instead.","ref":"Vtc.Framerate.html#new!/2","title":"Vtc.Framerate.new!/2","type":"function"},{"doc":"Returns true if the value represents and NTSC framerate. Will return true on a Framerate with an :ntsc value of :non_drop and :drop .","ref":"Vtc.Framerate.html#ntsc?/1","title":"Vtc.Framerate.ntsc?/1","type":"function"},{"doc":"The rational representation of the SMPTE timecode's 'logical speed'. For more on timebase and it's relationship to framerate, see: NTSC: Framerate vs timebase . Returned value is in frames-per-second.","ref":"Vtc.Framerate.html#timebase/1","title":"Vtc.Framerate.timebase/1","type":"function"},{"doc":"Options for new/2 and new!/2 .","ref":"Vtc.Framerate.html#t:new_opts/0","title":"Vtc.Framerate.new_opts/0","type":"type"},{"doc":"Enum of Ntsc types. Values :non_drop A non-drop NTSC value. :drop A drop-frame ntsc value. nil : Not an NTSC value For more information on NTSC standards and framerate conventions, see Frame.io's blogpost on the subject.","ref":"Vtc.Framerate.html#t:ntsc/0","title":"Vtc.Framerate.ntsc/0","type":"type"},{"doc":"Type returned by new/2","ref":"Vtc.Framerate.html#t:parse_result/0","title":"Vtc.Framerate.parse_result/0","type":"type"},{"doc":"Type of Framerate","ref":"Vtc.Framerate.html#t:t/0","title":"Vtc.Framerate.t/0","type":"type"},{"doc":"Holds a timecode range. Struct Fields in : Start TC. Must be less than or equal to out . out : End TC. Must be greater than or equal to in . inclusive : See below for more information. Default: false Inclusive vs. Exclusive Ranges Inclusive ranges treat the out timecode as the last visible frame of a piece of footage. This style of tc range is most often associated with AVID. Exclusive timecode ranges treat the out timecode as the boundary where the range ends. This style of tc range is most often associated with Final Cut and Premiere. In mathematical notation, inclusive ranges are [in, out] , while exclusive ranges are [in, out) .","ref":"Vtc.Range.html","title":"Vtc.Range","type":"module"},{"doc":"Returns true if range contains timecode . timecode may be any value that implements Frames . Examples iex&gt; tc_in = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; range = Range . new! ( tc_in , &quot;01:30:00:00&quot; ) iex&gt; iex&gt; Range . contains? ( range , &quot;01:10:00:00&quot; ) true iex&gt; Range . contains? ( range , &quot;01:40:00:00&quot; ) false","ref":"Vtc.Range.html#contains?/2","title":"Vtc.Range.contains?/2","type":"function"},{"doc":"Returns the duration in Timecode of range . Examples iex&gt; tc_in = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; range = Range . new! ( tc_in , &quot;01:30:00:00&quot; ) iex&gt; iex&gt; result = Range . duration ( range ) iex&gt; inspect ( result ) &quot;&lt;00:30:00:00 &lt;23.98 NTSC&gt;&gt;&quot;","ref":"Vtc.Range.html#duration/1","title":"Vtc.Range.duration/1","type":"function"},{"doc":"Returns the the range where a and b overlap/intersect. Returns nil if the two ranges do not intersect. a and b do not have to have matching :out_type settings, but the result will inherit a 's setting. Examples iex&gt; a_in = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; a = Range . new! ( a_in , &quot;02:00:00:00&quot; , out_type : :inclusive ) iex&gt; iex&gt; b_in = Timecode . with_frames! ( &quot;01:50:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Range . new! ( b_in , &quot;02:30:00:00&quot; , out_type : :inclusive ) iex&gt; iex&gt; result = Range . intersection ( a , b ) iex&gt; inspect ( result ) &quot;{:ok, &lt;01:50:00:00 - 02:00:00:00 :inclusive &lt;23.98 NTSC&gt;&gt;}&quot; iex&gt; a_in = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; a = Range . new! ( a_in , &quot;02:00:00:00&quot; , out_type : :inclusive ) iex&gt; iex&gt; b_in = Timecode . with_frames! ( &quot;02:10:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Range . new! ( b_in , &quot;03:30:00:00&quot; , out_type : :inclusive ) iex&gt; Range . intersection ( a , b ) { :error , :none }","ref":"Vtc.Range.html#intersection/2","title":"Vtc.Range.intersection/2","type":"function"},{"doc":"As intersection , but returns a Range from 00:00:00:00 - 00:00:00:00 when there is no overlap. This returned range inherets the framerate and out_type from a . Examples iex&gt; a_in = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; a = Range . new! ( a_in , &quot;02:00:00:00&quot; , out_type : :inclusive ) iex&gt; iex&gt; b_in = Timecode . with_frames! ( &quot;02:10:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Range . new! ( b_in , &quot;03:30:00:00&quot; , out_type : :inclusive ) iex&gt; iex&gt; result = Range . intersection! ( a , b ) iex&gt; inspect ( result ) &quot;&lt;00:00:00:00 - -00:00:00:01 :inclusive &lt;23.98 NTSC&gt;&gt;&quot;","ref":"Vtc.Range.html#intersection!/2","title":"Vtc.Range.intersection!/2","type":"function"},{"doc":"Creates a new Range . out_tc may be a Timecode value for any value that implements the Frames protocol. Returns an error if the resulting range would not have a duration greater or eual to 0, or if tc_in and tc_out do not have the same rate . Examples iex&gt; tc_in = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; tc_out = Timecode . with_frames! ( &quot;02:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Range . new ( tc_in , tc_out ) iex&gt; inspect ( result ) &quot;{:ok, &lt;01:00:00:00 - 02:00:00:00 :exclusive &lt;23.98 NTSC&gt;&gt;}&quot; Using a timecode string as b : iex&gt; tc_in = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Range . new ( tc_in , &quot;02:00:00:00&quot; ) iex&gt; inspect ( result ) &quot;{:ok, &lt;01:00:00:00 - 02:00:00:00 :exclusive &lt;23.98 NTSC&gt;&gt;}&quot; Making a range with an inclusive out: iex&gt; tc_in = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Range . new ( tc_in , &quot;02:00:00:00&quot; , out_type : :inclusive ) iex&gt; inspect ( result ) &quot;{:ok, &lt;01:00:00:00 - 02:00:00:00 :inclusive &lt;23.98 NTSC&gt;&gt;}&quot;","ref":"Vtc.Range.html#new/3","title":"Vtc.Range.new/3","type":"function"},{"doc":"As new/3 , but raises on error.","ref":"Vtc.Range.html#new!/3","title":"Vtc.Range.new!/3","type":"function"},{"doc":"Returns true if there is overlap between a and b . Examples iex&gt; a_in = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; a = Range . new! ( a_in , &quot;02:00:00:00&quot; , out_type : :inclusive ) iex&gt; iex&gt; b_in = Timecode . with_frames! ( &quot;01:50:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Range . new! ( b_in , &quot;02:30:00:00&quot; , out_type : :inclusive ) iex&gt; Range . overlaps? ( a , b ) true iex&gt; a_in = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; a = Range . new! ( a_in , &quot;02:00:00:00&quot; , out_type : :inclusive ) iex&gt; iex&gt; b_in = Timecode . with_frames! ( &quot;02:10:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Range . new! ( b_in , &quot;03:30:00:00&quot; , out_type : :inclusive ) iex&gt; Range . overlaps? ( a , b ) false","ref":"Vtc.Range.html#overlaps?/2","title":"Vtc.Range.overlaps?/2","type":"function"},{"doc":"Returns the range between two, non-overlapping ranges. Returns nil if the two ranges are not separated. a and b do not have to have matching :out_type settings, but the result will inherit a 's setting. Examples iex&gt; a_in = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; a = Range . new! ( a_in , &quot;02:00:00:00&quot; , out_type : :inclusive ) iex&gt; iex&gt; b_in = Timecode . with_frames! ( &quot;02:10:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Range . new! ( b_in , &quot;03:30:00:00&quot; , out_type : :inclusive ) iex&gt; iex&gt; result = Range . separation ( a , b ) iex&gt; inspect ( result ) &quot;{:ok, &lt;02:00:00:01 - 02:09:59:23 :inclusive &lt;23.98 NTSC&gt;&gt;}&quot; iex&gt; a_in = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; a = Range . new! ( a_in , &quot;02:00:00:00&quot; , out_type : :inclusive ) iex&gt; iex&gt; b_in = Timecode . with_frames! ( &quot;01:50:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Range . new! ( b_in , &quot;02:30:00:00&quot; , out_type : :inclusive ) iex&gt; Range . separation ( a , b ) { :error , :none }","ref":"Vtc.Range.html#separation/2","title":"Vtc.Range.separation/2","type":"function"},{"doc":"As separation , but returns a Range from 00:00:00:00 - 00:00:00:00 when there is overlap. This returned range inherets the framerate and out_type from a . Examples iex&gt; a_in = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; a = Range . new! ( a_in , &quot;02:00:00:00&quot; , out_type : :inclusive ) iex&gt; iex&gt; b_in = Timecode . with_frames! ( &quot;01:50:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Range . new! ( b_in , &quot;02:30:00:00&quot; , out_type : :inclusive ) iex&gt; iex&gt; result = Range . separation! ( a , b ) iex&gt; inspect ( result ) &quot;&lt;00:00:00:00 - -00:00:00:01 :inclusive &lt;23.98 NTSC&gt;&gt;&quot;","ref":"Vtc.Range.html#separation!/2","title":"Vtc.Range.separation!/2","type":"function"},{"doc":"Returns a range with an :in value of tc_in and a duration of duration . duration may be a Timecode value for any value that implements the Frames protocol. Returns an error if duration is less than 0 seconds or if tc_in and tc_out do not have the same rate . Examples iex&gt; start_tc = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; duration = Timecode . with_frames! ( &quot;00:30:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Range . with_duration ( start_tc , duration ) iex&gt; inspect ( result ) &quot;{:ok, &lt;01:00:00:00 - 01:30:00:00 :exclusive &lt;23.98 NTSC&gt;&gt;}&quot; Using a timecode string as b : iex&gt; start_tc = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Range . with_duration ( start_tc , &quot;00:30:00:00&quot; ) iex&gt; inspect ( result ) &quot;{:ok, &lt;01:00:00:00 - 01:30:00:00 :exclusive &lt;23.98 NTSC&gt;&gt;}&quot; Making a range with an inclusive out: iex&gt; start_tc = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Range . with_duration ( start_tc , &quot;00:30:00:00&quot; , out_type : :inclusive ) iex&gt; inspect ( result ) &quot;{:ok, &lt;01:00:00:00 - 01:29:59:23 :inclusive &lt;23.98 NTSC&gt;&gt;}&quot;","ref":"Vtc.Range.html#with_duration/3","title":"Vtc.Range.with_duration/3","type":"function"},{"doc":"As with_duration/3, but raises on error.","ref":"Vtc.Range.html#with_duration!/3","title":"Vtc.Range.with_duration!/3","type":"function"},{"doc":"Adjusts range to have an exclusive out timecode. Examples iex&gt; tc_in = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; range = Range . new! ( tc_in , &quot;02:00:00:00&quot; , out_type : :inclusive ) iex&gt; iex&gt; result = Range . with_exclusive_out ( range ) iex&gt; inspect ( result ) &quot;&lt;01:00:00:00 - 02:00:00:01 :exclusive &lt;23.98 NTSC&gt;&gt;&quot;","ref":"Vtc.Range.html#with_exclusive_out/1","title":"Vtc.Range.with_exclusive_out/1","type":"function"},{"doc":"Adjusts range to have an inclusive out timecode. Examples iex&gt; tc_in = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; range = Range . new! ( tc_in , &quot;02:00:00:00&quot; ) iex&gt; iex&gt; result = Range . with_inclusive_out ( range ) iex&gt; inspect ( result ) &quot;&lt;01:00:00:00 - 01:59:59:23 :inclusive &lt;23.98 NTSC&gt;&gt;&quot;","ref":"Vtc.Range.html#with_inclusive_out/1","title":"Vtc.Range.with_inclusive_out/1","type":"function"},{"doc":"Whether the end point should be treated as the Range's boundary (:exclusive), or its last element (:inclusive).","ref":"Vtc.Range.html#t:out_type/0","title":"Vtc.Range.out_type/0","type":"type"},{"doc":"Range struct type.","ref":"Vtc.Range.html#t:t/0","title":"Vtc.Range.t/0","type":"type"},{"doc":"Represents a particular frame in a video clip. New Timecode values are created with the with_seconds/3 and with_frames/2 , and other function prefaced by with_* . Struct Fields seconds : The real-world seconds elapsed since 01:00:00:00 as a rational value. (Note: The Ratio module automatically will coerce itself to an integer whenever possible, so this value may be an integer when exactly a whole-second value). rate : the Framerate of the timecode. Sorting Support Timecode implements compare/2 , and as such, can be used wherever the standard library calls for a Sorter module. Let's see it in action: iex&gt; tc_01 = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; tc_02 = Timecode . with_frames! ( &quot;02:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; sorted = Enum . sort ( [ tc_02 , tc_01 ] , Timecode ) iex&gt; inspect ( sorted ) &quot;[&lt;01:00:00:00 &lt;23.98 NTSC&gt;&gt;, &lt;02:00:00:00 &lt;23.98 NTSC&gt;&gt;]&quot; iex&gt; sorted = Enum . sort ( [ tc_01 , tc_02 ] , { :desc , Timecode } ) iex&gt; inspect ( sorted ) &quot;[&lt;02:00:00:00 &lt;23.98 NTSC&gt;&gt;, &lt;01:00:00:00 &lt;23.98 NTSC&gt;&gt;]&quot; iex&gt; max = Enum . max ( [ tc_02 , tc_01 ] , Timecode ) iex&gt; inspect ( max ) &quot;&lt;02:00:00:00 &lt;23.98 NTSC&gt;&gt;&quot; iex&gt; min = Enum . min ( [ tc_02 , tc_01 ] , Timecode ) iex&gt; inspect ( min ) &quot;&lt;01:00:00:00 &lt;23.98 NTSC&gt;&gt;&quot; iex&gt; data_01 = %{ id : 2 , tc : tc_01 } iex&gt; data_02 = %{ id : 1 , tc : tc_02 } iex&gt; sorted = Enum . sort_by ( [ data_02 , data_01 ] , &amp; &amp;1 . tc , Timecode ) iex&gt; inspect ( sorted ) &quot;[%{id: 2, tc: &lt;01:00:00:00 &lt;23.98 NTSC&gt;&gt;}, %{id: 1, tc: &lt;02:00:00:00 &lt;23.98 NTSC&gt;&gt;}]&quot; Arithmetic Autocasting For operators that take two timecode values , likt add/3 or compare/2 , as long as one argument is a Timecode value, a or b May be any value that implements the Frames protocol, such as a timecode string, and will be assumed to be the same framerate as the other. This is mostly to support quick scripting. If parsing the value fails during casting, the function raises a Vtc.Timecode.ParseError . Parsing: Seconds.t() or Frames.t() Parsing functions preappend with_ to their name. When you give a value to a parsing function, it is the same value that would be returned by the euivalent unit conversion. So a value passed to with_frames is the same value frames would return: iex&gt; { :ok , timecode } = Timecode . with_frames ( 24 , Rates . f23_98 ( ) ) iex&gt; inspect ( timecode ) &quot;&lt;00:00:01:00 &lt;23.98 NTSC&gt;&gt;&quot; iex&gt; Timecode . frames ( timecode ) 24 The Timecode module only has two basic construction / parsing methods: with_seconds and with_frames . At first blush, this may seem... odd. Where is with_timecode/2 ? Or with_premiere_ticks/2 ? We can render these formats, so why isn't there a parser for them? Well there is, sort of: the two functions above. One of the major conceits of Vtc is that all of the various ways of representing a video frame's timestamp boil down to EITHER: a) A representation of an index number for that frame OR b) A representation of the real-world seconds the frame occurred at. Timecode is really a human-readable way to represent a frame number. Same with film feet+frames. Premiere Ticks, on the other hand, represents a real-world seconds value, as broken down in 1/254_016_000_000ths of a second. Instead of polluting the module's namespace with a range of constructors, Vtc declares a Frames protocol for types that represent a frame count, and a Seconds protocol for types that represent a time-scalar. All timecode representations eventually get funnelled through one of these protocols. For instance, when the String implementation of the protocol detects a SMPTE timecode string, it wraps the value in a TimecodeStr struct which handles converting that string to a frame number thorough implementing the Frames protocol. That frame number is then taken by with_frames and converted to a rational seconds value. Going through protocols allows callers to define their own types that work with Vtc's parsing functions directly.","ref":"Vtc.Timecode.html","title":"Vtc.Timecode","type":"module"},{"doc":"Returns the absolute value of tc . Examples iex&gt; tc = Timecode . with_frames! ( &quot;-01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Timecode . abs ( tc ) iex&gt; inspect ( result ) &quot;&lt;01:00:00:00 &lt;23.98 NTSC&gt;&gt;&quot; iex&gt; tc = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Timecode . abs ( tc ) iex&gt; inspect ( result ) &quot;&lt;01:00:00:00 &lt;23.98 NTSC&gt;&gt;&quot;","ref":"Vtc.Timecode.html#abs/1","title":"Vtc.Timecode.abs/1","type":"function"},{"doc":"Add two timecodes. Uses the real-world seconds representation. When the rates of a and b are not equal, the result will inheret the framerate of a and be rounded to the seconds representation of the nearest whole-frame at that rate. auto-casts Frames values. Options round : How to round the result with respect to whole-frames when mixing framerates. Default: :closest . Examples Two timecodes running at the same rate: iex&gt; a = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Timecode . with_frames! ( &quot;01:30:21:17&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Timecode . add ( a , b ) iex&gt; inspect ( result ) &quot;&lt;02:30:21:17 &lt;23.98 NTSC&gt;&gt;&quot; Two timecodes running at different rates: iex&gt; a = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Timecode . with_frames! ( &quot;00:00:00:02&quot; , Rates . f47_95 ( ) ) iex&gt; iex&gt; result = Timecode . add ( a , b ) iex&gt; inspect ( result ) &quot;&lt;01:00:00:01 &lt;23.98 NTSC&gt;&gt;&quot; Using a timecode and a bare string: iex&gt; a = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Timecode . add ( a , &quot;01:30:21:17&quot; ) iex&gt; inspect ( result ) &quot;&lt;02:30:21:17 &lt;23.98 NTSC&gt;&gt;&quot;","ref":"Vtc.Timecode.html#add/3","title":"Vtc.Timecode.add/3","type":"function"},{"doc":"Comapare the values of a and b . Compatible with Enum.sort/2 . For more on sorting non-builtin values, see the Elixir ducumentation . auto-casts Frames values. See eq?/2 for more information on how equality is determined. Examples Using two timecodes, 01:00:00:00 NTSC is greater than 01:00:00:00 true because it represents more real-world time. iex&gt; a = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f24 ( ) ) iex&gt; :gt = Timecode . compare ( a , b ) Using a timecode and a bare string: iex&gt; timecode = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; :eq = Timecode . compare ( timecode , &quot;01:00:00:00&quot; )","ref":"Vtc.Timecode.html#compare/2","title":"Vtc.Timecode.compare/2","type":"function"},{"doc":"Divides dividend by divisor . The result will inherit the framerate of dividend and rounded to the nearest whole-frame based on the :round option. Options round : How to round the result with respect to whole-frame values. Defaults to :floor to match divmod and the expected meaning of div to mean integer division in elixir. Examples iex&gt; dividend = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Timecode . div ( dividend , 2 ) iex&gt; inspect ( result ) &quot;&lt;00:30:00:00 &lt;23.98 NTSC&gt;&gt;&quot; iex&gt; dividend = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Timecode . div ( dividend , 0.5 ) iex&gt; inspect ( result ) &quot;&lt;02:00:00:00 &lt;23.98 NTSC&gt;&gt;&quot;","ref":"Vtc.Timecode.html#div/3","title":"Vtc.Timecode.div/3","type":"function"},{"doc":"Divides the total frame count of dividend by divisor and returns both a quotient and a remainder. The quotient returned is equivalent to Timecode.div/3 with the :round option set to :floor . Options round_frames : How to round the frame count before doing the divrem operation. Default: :closest . round_remainder : How to round the remainder frames when a non-whole frame would be the result. Default: :closest . Examples iex&gt; dividend = Timecode . with_frames! ( &quot;01:00:00:01&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Timecode . divrem ( dividend , 4 ) iex&gt; inspect ( result ) &quot;{&lt;00:15:00:00 &lt;23.98 NTSC&gt;&gt;, &lt;00:00:00:01 &lt;23.98 NTSC&gt;&gt;}&quot;","ref":"Vtc.Timecode.html#divrem/3","title":"Vtc.Timecode.divrem/3","type":"function"},{"doc":"Returns true if a is eqaul to b . auto-casts Frames values. Examples iex&gt; a = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; true = Timecode . eq? ( a , b ) Timecodes with the same string representation, but different real-world seconds values, are not equal: iex&gt; a = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f24 ( ) ) iex&gt; false = Timecode . eq? ( a , b ) But Timecodes with the different string representation, but the same real-world seconds values, are equal: iex&gt; a = Timecode . with_frames! ( &quot;01:00:00:12&quot; , Rates . f23_98 ( ) ) iex&gt; b = Timecode . with_frames! ( &quot;01:00:00:24&quot; , Rates . f47_95 ( ) ) iex&gt; true = Timecode . eq? ( a , b )","ref":"Vtc.Timecode.html#eq?/2","title":"Vtc.Timecode.eq?/2","type":"function"},{"doc":"Evalutes timecode mathematical expressions in a do block. Any code captured within this macro can use Kernel operators to work with timecode values instead of module functions like add/2 . Options at : The Framerate to cast non-timecode values to. If this value is not set, then at least one value in each operation must be a Timecode . This value can be any value accepted by Framerate.new/2 . ntsc : The ntsc value to use when creating a new Framerate with at . Not needed if at is a Framerate value. Examples Use eval to do some quick math. The block captures variables from the outer scope, but contains the expression within its own scope, just like an if or with statement. iex&gt; require Timecode iex&gt; iex&gt; a = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Timecode . with_frames! ( &quot;00:30:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; c = Timecode . with_frames! ( &quot;00:15:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = iex&gt; Timecode . eval do iex&gt; a + b * 2 - c iex&gt; end iex&gt; iex&gt; inspect ( result ) &quot;&lt;01:45:00:00 &lt;23.98 NTSC&gt;&gt;&quot; Or if you want to do it in one line: iex&gt; require Timecode iex&gt; iex&gt; a = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Timecode . with_frames! ( &quot;00:30:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; c = Timecode . with_frames! ( &quot;00:15:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Timecode . eval ( a + b * 2 - c ) iex&gt; iex&gt; inspect ( result ) &quot;&lt;01:45:00:00 &lt;23.98 NTSC&gt;&gt;&quot; Just like the regular Timecode functions, only one value in an arithmetic expression needs to be a Timecode value. In the case above, since multiplication happens first, that's b : iex&gt; b = Timecode . with_frames! ( &quot;00:30:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = iex&gt; Timecode . eval do iex&gt; &quot;01:00:00:00&quot; + b * 2 - &quot;00:15:00:00&quot; iex&gt; end iex&gt; iex&gt; inspect ( result ) &quot;&lt;01:45:00:00 &lt;23.98 NTSC&gt;&gt;&quot; You can supply a default framerate if you just want to do some quick calculations. This framerate is inherited by every value that implements the Frames protocol in the block, including integers: iex&gt; result = iex&gt; Timecode . eval at : Rates . f23_98 ( ) do iex&gt; &quot;01:00:00:00&quot; + &quot;00:30:00:00&quot; * 2 - &quot;00:15:00:00&quot; iex&gt; end iex&gt; iex&gt; inspect ( result ) &quot;&lt;01:45:00:00 &lt;23.98 NTSC&gt;&gt;&quot; You can use any value that can be parsed by Framerate.new/2 . iex&gt; result = iex&gt; Timecode . eval at : 23.98 do iex&gt; &quot;01:00:00:00&quot; + &quot;00:30:00:00&quot; * 2 - &quot;00:15:00:00&quot; iex&gt; end iex&gt; iex&gt; inspect ( result ) &quot;&lt;01:45:00:00 &lt;23.98 NTSC&gt;&gt;&quot; ntsc: :non_drop, coerce_ntsc?: true is assumed by default, but you can set a different value with the :ntsc option: iex&gt; result = iex&gt; Timecode . eval at : 24 , ntsc : nil do iex&gt; &quot;01:00:00:00&quot; + &quot;00:30:00:00&quot; * 2 - &quot;00:15:00:00&quot; iex&gt; end iex&gt; iex&gt; inspect ( result ) &quot;&lt;01:45:00:00 &lt;24.0 fps&gt;&gt;&quot;","ref":"Vtc.Timecode.html#eval/2","title":"Vtc.Timecode.eval/2","type":"macro"},{"doc":"Returns the number of physical film feet and frames timecode represents if shot on film. Ex: '5400+13'. Options round : How to round the internal frame count before conversion. Default: :closest . fiim_format : The film format to use when doing the calculation. For more on film formats, see Vtc.FilmFormat . Default: :ff35mm_4perf , by far the most common format used to shoot Hollywood movies. What it is On physical film, each foot contains a certain number of frames. For 35mm, 4-perf film (the most common type on Hollywood movies), this number is 16 frames per foot. Feet-And-Frames was often used in place of Keycode to quickly reference a frame in the edit. Where you see it For the most part, feet + frames has died out as a reference, because digital media is not measured in feet. The most common place it is still used is Studio Sound Departments. Many Sound Mixers and Designers intuitively think in feet + frames, and it is often burned into the reference picture for them. Telecine. Sound turnover reference picture. Sound turnover change lists. For more information on individual film formats, see the Vtc.FilmFormat module. Examples Defaults to 35mm, 4perf: iex&gt; timecode = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Timecode . feet_and_frames ( timecode ) iex&gt; inspect ( result ) &quot;&lt;5400+00 :ff35mm_4perf&gt;&quot; Use String.Chars to convert the resulting struct to a traditional F=F string: iex&gt; alias Vtc.Source.Frames.FeetAndFrames iex&gt; iex&gt; timecode = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Timecode . feet_and_frames ( timecode ) iex&gt; String.Chars . to_string ( result ) &quot;5400+00&quot; Outputting as a different film format: Examples iex&gt; timecode = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Timecode . feet_and_frames ( timecode , film_format : :ff16mm ) iex&gt; inspect ( result ) &quot;&lt;4320+00 :ff16mm&gt;&quot;","ref":"Vtc.Timecode.html#feet_and_frames/2","title":"Vtc.Timecode.feet_and_frames/2","type":"function"},{"doc":"Returns the number of frames that would have elapsed between 00:00:00:00 and timecode . Options round : How to round the resulting frame number. What it is Frame number / frames count is the number of a frame if the timecode started at 00:00:00:00 and had been running until the current value. A timecode of '00:00:00:10' has a frame number of 10. A timecode of '01:00:00:00' has a frame number of 86400. Where you see it Frame-sequence files: 'my_vfx_shot.0086400.exr' FCP7XML cut lists: &lt;timecode&gt; &lt;rate&gt; &lt;timebase&gt;24&lt;/timebase&gt; &lt;ntsc&gt;TRUE&lt;/ntsc&gt; &lt;/rate&gt; &lt;string&gt;01:00:00:00&lt;/string&gt; &lt;frame&gt;86400&lt;/frame&gt; &lt;!-- &lt;====THIS LINE--&gt; &lt;displayformat&gt;NDF&lt;/displayformat&gt; &lt;/timecode&gt; Examples iex&gt; timecode = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; Timecode . frames ( timecode ) 86400","ref":"Vtc.Timecode.html#frames/2","title":"Vtc.Timecode.frames/2","type":"function"},{"doc":"Returns true if a is greater than b . auto-casts Frames values. See eq?/2 for more information on how equality is determined.","ref":"Vtc.Timecode.html#gt?/2","title":"Vtc.Timecode.gt?/2","type":"function"},{"doc":"Returns true if a is greater than or eqaul to b . auto-casts Frames values. See eq?/2 for more information on how equality is determined.","ref":"Vtc.Timecode.html#gte?/2","title":"Vtc.Timecode.gte?/2","type":"function"},{"doc":"Returns true if a is less than b . auto-casts Frames values. See eq?/2 for more information on how equality is determined. Examples iex&gt; a = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Timecode . with_frames! ( &quot;02:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; true = Timecode . lt? ( a , b ) iex&gt; false = Timecode . lt? ( b , a )","ref":"Vtc.Timecode.html#lt?/2","title":"Vtc.Timecode.lt?/2","type":"function"},{"doc":"Returns true if a is less than or equal to b . auto-casts Frames values. See eq?/2 for more information on how equality is determined.","ref":"Vtc.Timecode.html#lte?/2","title":"Vtc.Timecode.lte?/2","type":"function"},{"doc":"As the kernel -/1 function. Makes a positive tc value negative. Makes a negative tc value positive. Examples iex&gt; tc = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Timecode . minus ( tc ) iex&gt; inspect ( result ) &quot;&lt;-01:00:00:00 &lt;23.98 NTSC&gt;&gt;&quot; iex&gt; tc = Timecode . with_frames! ( &quot;-01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Timecode . minus ( tc ) iex&gt; inspect ( result ) &quot;&lt;01:00:00:00 &lt;23.98 NTSC&gt;&gt;&quot;","ref":"Vtc.Timecode.html#minus/1","title":"Vtc.Timecode.minus/1","type":"function"},{"doc":"Scales a by b . The result will inheret the framerate of a and be rounded to the seconds representation of the nearest whole-frame based on the :round option. Options round : How to round the result with respect to whole-frame values. Defaults to :closest . Examples iex&gt; a = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Timecode . mult ( a , 2 ) iex&gt; inspect ( result ) &quot;&lt;02:00:00:00 &lt;23.98 NTSC&gt;&gt;&quot; iex&gt; a = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Timecode . mult ( a , 0.5 ) iex&gt; inspect ( result ) &quot;&lt;00:30:00:00 &lt;23.98 NTSC&gt;&gt;&quot;","ref":"Vtc.Timecode.html#mult/3","title":"Vtc.Timecode.mult/3","type":"function"},{"doc":"Returns the number of elapsed ticks timecode represents in Adobe Premiere Pro. Options round : How to round the resulting ticks. What it is Internally, Adobe Premiere Pro uses ticks to divide up a second, and keep track of how far into that second we are. There are 254016000000 ticks in a second, regardless of framerate in Premiere. Where you see it Premiere Pro Panel functions and scripts. FCP7XML cutlists generated from Premiere: &lt;clipitem id=&quot;clipitem-1&quot;&gt; ... &lt;in&gt;158&lt;/in&gt; &lt;out&gt;1102&lt;/out&gt; &lt;pproTicksIn&gt;1673944272000&lt;/pproTicksIn&gt; &lt;pproTicksOut&gt;11675231568000&lt;/pproTicksOut&gt; ... &lt;/clipitem&gt; Examples iex&gt; timecode = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; Timecode . premiere_ticks ( timecode ) 915372057600000","ref":"Vtc.Timecode.html#premiere_ticks/2","title":"Vtc.Timecode.premiere_ticks/2","type":"function"},{"doc":"Rebases timecode to a new framerate. The real-world seconds are recalculated using the same frame count as if they were being played back at new_rate instead of timecode.rate . Examples iex&gt; timecode = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; { :ok , rebased } = Timecode . rebase ( timecode , Rates . f47_95 ( ) ) iex&gt; inspect ( rebased ) &quot;&lt;00:30:00:00 &lt;47.95 NTSC&gt;&gt;&quot;","ref":"Vtc.Timecode.html#rebase/2","title":"Vtc.Timecode.rebase/2","type":"function"},{"doc":"As rebase/2 , but raises on error.","ref":"Vtc.Timecode.html#rebase!/2","title":"Vtc.Timecode.rebase!/2","type":"function"},{"doc":"Devides the total frame count of dividend by devisor , and returns the remainder. The quotient is floored before the remainder is calculated. Options round_frames : How to round the frame count before doing the rem operation. Default: :closest . round_remainder : How to round the remainder frames when a non-whole frame would be the result. Default: :closest . Examples iex&gt; dividend = Timecode . with_frames! ( &quot;01:00:00:01&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Timecode . rem ( dividend , 4 ) iex&gt; inspect ( result ) &quot;&lt;00:00:00:01 &lt;23.98 NTSC&gt;&gt;&quot;","ref":"Vtc.Timecode.html#rem/3","title":"Vtc.Timecode.rem/3","type":"function"},{"doc":"Runtime Returns the true, real-world runtime of timecode in HH:MM:SS.FFFFFFFFF format. Trailing zeroes are trimmed from the end of the return value. If the entire fractal seconds value would be trimmed, '.0' is used. Options precision : The number of places to round to. Extra trailing 0's will still be trimmed. Default: 9 . trim_zeros? : Whether to trim trailing zeroes. Default: true . What it is The formatted version of seconds. It looks like timecode, but with a decimal seconds value instead of a frame number place. Where you see it • Anywhere real-world time is used. • FFMPEG commands: ffmpeg -ss 00:00:30.5 -i input.mov -t 00:00:10.25 output.mp4 Note The true runtime will often diverge from the hours, minutes, and seconds value of the timecode representation when dealing with non-whole-frame framerates. Even drop-frame timecode does not continuously adhere 1:1 to the actual runtime. For instance, &lt;01:00:00;00 &lt;29.97 NTSC DF&gt;&gt; has a true runtime of '00:59:59.9964', and &lt;01:00:00:00 &lt;23.98 NTSC&gt;&gt; has a true runtime of '01:00:03.6' Examples iex&gt; timecode = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; Timecode . runtime ( timecode ) &quot;01:00:03.6&quot;","ref":"Vtc.Timecode.html#runtime/2","title":"Vtc.Timecode.runtime/2","type":"function"},{"doc":"The individual sections of a timecode string as i64 values. Examples iex&gt; timecode = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Timecode . sections ( timecode ) iex&gt; inspect ( result ) &quot;%Vtc.Timecode.Sections{negative?: false, hours: 1, minutes: 0, seconds: 0, frames: 0}&quot;","ref":"Vtc.Timecode.html#sections/2","title":"Vtc.Timecode.sections/2","type":"function"},{"doc":"Subtract b from a . Uses their real-world seconds representation. When the rates of a and b are not equal, the result will inheret the framerate of a and be rounded to the seconds representation of the nearest whole-frame at that rate. auto-casts Frames values. Options round : How to round the result with respect to whole-frames when mixing framerates. Default: :closest . Examples Two timecodes running at the same rate: iex&gt; a = Timecode . with_frames! ( &quot;01:30:21:17&quot; , Rates . f23_98 ( ) ) iex&gt; b = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Timecode . sub ( a , b ) iex&gt; inspect ( result ) &quot;&lt;00:30:21:17 &lt;23.98 NTSC&gt;&gt;&quot; When b is greater than a , the result is negative: iex&gt; a = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Timecode . with_frames! ( &quot;02:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Timecode . sub ( a , b ) iex&gt; inspect ( result ) &quot;&lt;-01:00:00:00 &lt;23.98 NTSC&gt;&gt;&quot; Two timecodes running at different rates: iex&gt; a = Timecode . with_frames! ( &quot;01:00:00:02&quot; , Rates . f23_98 ( ) ) iex&gt; b = Timecode . with_frames! ( &quot;00:00:00:02&quot; , Rates . f47_95 ( ) ) iex&gt; iex&gt; result = Timecode . sub ( a , b ) iex&gt; inspect ( result ) &quot;&lt;01:00:00:01 &lt;23.98 NTSC&gt;&gt;&quot; Using a timecode and a bare string: iex&gt; a = Timecode . with_frames! ( &quot;01:30:21:17&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; result = Timecode . sub ( a , &quot;01:00:00:00&quot; ) iex&gt; inspect ( result ) &quot;&lt;00:30:21:17 &lt;23.98 NTSC&gt;&gt;&quot;","ref":"Vtc.Timecode.html#sub/3","title":"Vtc.Timecode.sub/3","type":"function"},{"doc":"Returns the the formatted SMPTE timecode Ex: 01:00:00:00 . Drop frame timecode will be rendered with a ';' sperator before the frames field. Options round : How to round the resulting frames field. What it is Timecode is used as a human-readable way to represent the id of a given frame. It is formatted to give a rough sense of where to find a frame: {HOURS}:{MINUTES}:{SECONDS}:{FRAME} . For more on timecode, see Frame.io's excellent post on the subject. Where you see it Timecode is ubiquitous in video editing, a small sample of places you might see timecode: Source and Playback monitors in your favorite NLE. Burned into the footage for dailies. Cut lists like an EDL. Examples iex&gt; timecode = Timecode . with_frames! ( 86_400 , Rates . f23_98 ( ) ) iex&gt; Timecode . timecode ( timecode ) &quot;01:00:00:00&quot;","ref":"Vtc.Timecode.html#timecode/2","title":"Vtc.Timecode.timecode/2","type":"function"},{"doc":"Returns a new Timecode with a frames/2 return value equal to the frames arg. Arguments frames : A value which can be represented as a frame number / frame count. Must implement the Frames protocol. rate : Frame-per-second playback value of the timecode. Options round : How to round the result with regards to whole-frames. Examples Accepts timecode strings... iex&gt; result = Timecode . with_frames ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; inspect ( result ) &quot;{:ok, &lt;01:00:00:00 &lt;23.98 NTSC&gt;&gt;}&quot; ... feet+frames strings... iex&gt; result = Timecode . with_frames ( &quot;5400+00&quot; , Rates . f23_98 ( ) ) iex&gt; inspect ( result ) &quot;{:ok, &lt;01:00:00:00 &lt;23.98 NTSC&gt;&gt;}&quot; By default, feet+frames is interpreted as 35mm, 4perf film. You can use the FeetAndFrames struct to parse other film formats: iex&gt; alias Vtc.Source.Frames.FeetAndFrames iex&gt; iex&gt; { :ok , feet_and_frames } = FeetAndFrames . from_string ( &quot;5400+00&quot; , film_format : :ff16mm ) iex&gt; iex&gt; result = Timecode . with_frames ( feet_and_frames , Rates . f23_98 ( ) ) iex&gt; inspect ( result ) &quot;{:ok, &lt;01:15:00:00 &lt;23.98 NTSC&gt;&gt;}&quot; ... integers... iex&gt; result = Timecode . with_frames ( 86_400 , Rates . f23_98 ( ) ) iex&gt; inspect ( result ) &quot;{:ok, &lt;01:00:00:00 &lt;23.98 NTSC&gt;&gt;}&quot; ... and integer strings. iex&gt; result = Timecode . with_frames ( &quot;86400&quot; , Rates . f23_98 ( ) ) iex&gt; inspect ( result ) &quot;{:ok, &lt;01:00:00:00 &lt;23.98 NTSC&gt;&gt;}&quot;","ref":"Vtc.Timecode.html#with_frames/2","title":"Vtc.Timecode.with_frames/2","type":"function"},{"doc":"As Timecode.with_frames/3 , but raises on error.","ref":"Vtc.Timecode.html#with_frames!/2","title":"Vtc.Timecode.with_frames!/2","type":"function"},{"doc":"Returns a new Timecode with a :seconds field value equal to the seconds arg. Arguments seconds : A value which can be represented as a number of real-world seconds. Must implement the Seconds protocol. rate : Frame-per-second playback value of the timecode. Options round : How to round the result with regards to whole-frames. Examples Accetps runtime strings... iex&gt; result = Timecode . with_seconds ( &quot;01:00:00.5&quot; , Rates . f23_98 ( ) ) iex&gt; inspect ( result ) &quot;{:ok, &lt;00:59:56:22 &lt;23.98 NTSC&gt;&gt;}&quot; ... floats... iex&gt; result = Timecode . with_seconds ( 3600.5 , Rates . f23_98 ( ) ) iex&gt; inspect ( result ) &quot;{:ok, &lt;00:59:56:22 &lt;23.98 NTSC&gt;&gt;}&quot; ... integers... iex&gt; result = Timecode . with_seconds ( 3600 , Rates . f23_98 ( ) ) iex&gt; inspect ( result ) &quot;{:ok, &lt;00:59:56:10 &lt;23.98 NTSC&gt;&gt;}&quot; ... integer Strings... iex&gt; result = Timecode . with_seconds ( &quot;3600&quot; , Rates . f23_98 ( ) ) iex&gt; inspect ( result ) &quot;{:ok, &lt;00:59:56:10 &lt;23.98 NTSC&gt;&gt;}&quot; ... and float strings. iex&gt; result = Timecode . with_seconds ( &quot;3600.5&quot; , Rates . f23_98 ( ) ) iex&gt; inspect ( result ) &quot;{:ok, &lt;00:59:56:22 &lt;23.98 NTSC&gt;&gt;}&quot; Premiere Ticks The Vtc.Source.Seconds.PremiereTicks struck implements the Seconds protocol and can be used to parse the format. This struct is not a general-purpose Module for the unit, and only exists to hint to the parsing function how it should be processed: iex&gt; alias Vtc.Source.Seconds.PremiereTicks iex&gt; iex&gt; input = % PremiereTicks { in : 254_016_000_000 } iex&gt; iex&gt; result = Timecode . with_seconds! ( input , Rates . f23_98 ( ) ) iex&gt; inspect ( result ) &quot;&lt;00:00:01:00 &lt;23.98 NTSC&gt;&gt;&quot;","ref":"Vtc.Timecode.html#with_seconds/3","title":"Vtc.Timecode.with_seconds/3","type":"function"},{"doc":"As with_seconds/3 , but raises on error.","ref":"Vtc.Timecode.html#with_seconds!/3","title":"Vtc.Timecode.with_seconds!/3","type":"function"},{"doc":"As round/0 , but includes :off option to disable rounding entirely. Not all functions exposed by this module make logical sense without some form of rouding, so :off will not be accepted by all functions.","ref":"Vtc.Timecode.html#t:maybe_round/0","title":"Vtc.Timecode.maybe_round/0","type":"type"},{"doc":"Type returned by with_seconds/3 and with_frames/3 .","ref":"Vtc.Timecode.html#t:parse_result/0","title":"Vtc.Timecode.parse_result/0","type":"type"},{"doc":"Valid values for rounding options. :closest : Round the to the closet whole frame. :floor : Always round down to the closest whole-frame. :ciel : Always round up to the closest whole-frame.","ref":"Vtc.Timecode.html#t:round/0","title":"Vtc.Timecode.round/0","type":"type"},{"doc":"Timecode type.","ref":"Vtc.Timecode.html#t:t/0","title":"Vtc.Timecode.t/0","type":"type"},{"doc":"Functions and types for working with physical film data.","ref":"Vtc.FilmFormat.html","title":"Vtc.FilmFormat","type":"module"},{"doc":"Perferations are the holes that run along the sides of a strip of film, and are used by the camera's sprocket to physically pull the film in place to be exposed. For more information, see this Wikipedia atricle . By default, returns the count in a 'logical' foot. Logical feet and 16mm 'Logicial foot' means each time XX rolls over when annotated in the XX+YY format. Threre are 40 perfs in a foot of 16mm film, but when annotated as XX+YY , XX rolls over every 6 inches rather than every foot. Options physical? : Return the physical number of feet rather than the logical number.","ref":"Vtc.FilmFormat.html#perfs_per_foot/2","title":"Vtc.FilmFormat.perfs_per_foot/2","type":"function"},{"doc":"Perferation count in a single frame of film.","ref":"Vtc.FilmFormat.html#perfs_per_frame/1","title":"Vtc.FilmFormat.perfs_per_frame/1","type":"function"},{"doc":"Enum-like type of supported film formats for Vtc. ff35mm_4perf 35mm 4-perf film (16 frames per foot). ex: '5400+13'. What it is On physical film, each foot contains a certain number of frames. For 35mm, 4-perf film (the most common type on Hollywood movies), this number is 16 frames per foot. Feet-and-frames was often used in place of Keycode to quickly reference a frame in the edit. Where you see it For the most part, feet + frames has died out as a reference, because digital media is not measured in feet. The most common place it is still used is Studio Sound Departments. Many Sound Mixers and Designers intuitively think in feet + frames, and it is often burned into the reference picture for them. Telecine. Sound turnover reference picture. Sound turnover change lists. ff35mm_2perf What it is 35mm 2-perf film records 32 frames in a foot of film, instead of the usual 16. This creates a negative image with a wide aspect ratio using standard spherical lenses and consumes half the footage per minute running time as standard 35mm, while having a grain profile somewhat better than 16mm while not as good as standard 35mm. Where you see it 35mm 2-perf formats are uncommon though still find occasional use, the process is usually marketed as &quot;Techniscope&quot;, the original trademark for Technicolor Italia's 2-perf format. It was historically very common in the Italian film industry prior to digital filmmaking, and is used on some contemporary films to obtain a film look while keeping stock and processing costs down. 16mm What it is On 16mm film, there are forty frames of film in each foot, one perforation per frame. However, 16mm film is edge coded every six inches, with twenty frames per code, so the footage &quot;1+19&quot; is succeeded by &quot;2+0&quot;. Where you see it 16mm telecines, 16mm edge codes.","ref":"Vtc.FilmFormat.html#t:t/0","title":"Vtc.FilmFormat.t/0","type":"type"},{"doc":"Pre-defined framerates commonly found in the wild.","ref":"Vtc.Rates.html","title":"Vtc.Rates","type":"module"},{"doc":"23.98 NTSC, non-drop.","ref":"Vtc.Rates.html#f23_98/0","title":"Vtc.Rates.f23_98/0","type":"function"},{"doc":"24 fps.","ref":"Vtc.Rates.html#f24/0","title":"Vtc.Rates.f24/0","type":"function"},{"doc":"29.97 NTSC, drop-frame.","ref":"Vtc.Rates.html#f29_97_df/0","title":"Vtc.Rates.f29_97_df/0","type":"function"},{"doc":"29.97 NTSC, non-drop.","ref":"Vtc.Rates.html#f29_97_ndf/0","title":"Vtc.Rates.f29_97_ndf/0","type":"function"},{"doc":"30 fps.","ref":"Vtc.Rates.html#f30/0","title":"Vtc.Rates.f30/0","type":"function"},{"doc":"47.95 NTSC non-drop.","ref":"Vtc.Rates.html#f47_95/0","title":"Vtc.Rates.f47_95/0","type":"function"},{"doc":"48 fps.","ref":"Vtc.Rates.html#f48/0","title":"Vtc.Rates.f48/0","type":"function"},{"doc":"59.94 NTSC drop-frame.","ref":"Vtc.Rates.html#f59_94_df/0","title":"Vtc.Rates.f59_94_df/0","type":"function"},{"doc":"59.94 NTSC non-drop.","ref":"Vtc.Rates.html#f59_94_ndf/0","title":"Vtc.Rates.f59_94_ndf/0","type":"function"},{"doc":"60 fps.","ref":"Vtc.Rates.html#f60/0","title":"Vtc.Rates.f60/0","type":"function"},{"doc":"Holds the individual sections of a timecode for formatting / manipulation. Struct Fields negative : Whether the timecode is less than 0. hours : Hours place value. minutes : Minutes place value. This is not the toal minutes, but the minutes added to hours to get a final time. seconds : Seconds place value. As minutes, remainder value rather than total value. frames : Frames place value. As seconds, remainder value rather than total value.","ref":"Vtc.Timecode.Sections.html","title":"Vtc.Timecode.Sections","type":"module"},{"doc":"Struct type.","ref":"Vtc.Timecode.Sections.html#t:t/0","title":"Vtc.Timecode.Sections.t/0","type":"type"},{"doc":"Holds Feet+Frames information. Fields feet : The amount of film in Feet that would run through the camera in a given amount of time. feet : The number of frames left over after feet of film has run. film_format : The type of film this value represents. Default: :ff35mm_4perf . String Conversion FeetAndFrames can be converted into a string through the String.Chars.to_string/1 function. Examples iex&gt; alias Vtc.Source.Frames.FeetAndFrames iex&gt; iex&gt; String.Chars . to_string ( % FeetAndFrames { feet : 10 , frames : 4 } ) &quot;10+04&quot;","ref":"Vtc.Source.Frames.FeetAndFrames.html","title":"Vtc.Source.Frames.FeetAndFrames","type":"module"},{"doc":"Parses a FeetAndFrames value from a string.","ref":"Vtc.Source.Frames.FeetAndFrames.html#from_string/2","title":"Vtc.Source.Frames.FeetAndFrames.from_string/2","type":"function"},{"doc":"Parses a FeetAndFrames value from a string.","ref":"Vtc.Source.Frames.FeetAndFrames.html#from_string!/2","title":"Vtc.Source.Frames.FeetAndFrames.from_string!/2","type":"function"},{"doc":"Contains only a single field for wrapping the underlying string.","ref":"Vtc.Source.Frames.FeetAndFrames.html#t:t/0","title":"Vtc.Source.Frames.FeetAndFrames.t/0","type":"type"},{"doc":"Implementation of Frames for timecode string. See Vtc.Timecode.timecode/2 for more information on this format. This struct is used as an input wrapper only, not as the general-purpose Premiere ticks unit. By default, this wrapper does not need to be used by callers, as the string implementation of the frames protocol calls this type's impl automatically. Only use this type if you do not wish for the parser to fall back to feet+frames parsing as well.","ref":"Vtc.Source.Frames.TimecodeStr.html","title":"Vtc.Source.Frames.TimecodeStr","type":"module"},{"doc":"Contains only a single field for wrapping the underlying string.","ref":"Vtc.Source.Frames.TimecodeStr.html#t:t/0","title":"Vtc.Source.Frames.TimecodeStr.t/0","type":"type"},{"doc":"Implements Seconds protocol for Premiere ticks. See Vtc.Timecode.premiere_ticks/2 for more information on this unit. This struct is used as an input wrapper only, not as the general-purpose Premiere ticks unit.","ref":"Vtc.Source.Seconds.PremiereTicks.html","title":"Vtc.Source.Seconds.PremiereTicks","type":"module"},{"doc":"Returns the number of ticks in a second.","ref":"Vtc.Source.Seconds.PremiereTicks.html#per_second/0","title":"Vtc.Source.Seconds.PremiereTicks.per_second/0","type":"function"},{"doc":"Contains only a single field for wrapping the underlying integer.","ref":"Vtc.Source.Seconds.PremiereTicks.html#t:t/0","title":"Vtc.Source.Seconds.PremiereTicks.t/0","type":"type"},{"doc":"Implementation of Seconds for runtime strings. See Vtc.Timecode.runtime/2 for more information on this format. By default, this wrapper does not need to be used by callers, as the string implementation of the Seconds protocol calls this type's impl automatically. Only use this type if you do not wish for the parser to fall back to other type parsing as well.","ref":"Vtc.Source.Seconds.RuntimeStr.html","title":"Vtc.Source.Seconds.RuntimeStr","type":"module"},{"doc":"Contains only a single field for wrapping the underlying string.","ref":"Vtc.Source.Seconds.RuntimeStr.html#t:t/0","title":"Vtc.Source.Seconds.RuntimeStr.t/0","type":"type"},{"doc":"Protocol which types can implement to be passed as the main value of Timecode.with_frames/2 . Implementations Out of the box, this protocol is implemented for the following types: Integer String &amp; BitString timecode (&quot;01:00:00:00&quot;) integer (&quot;86400&quot;) Feet+Frames (&quot;5400+00&quot;) TimecodeStr FeetAndFrames","ref":"Vtc.Source.Frames.html","title":"Vtc.Source.Frames","type":"protocol"},{"doc":"Returns the value as a frame count. Arguments value : The source value. rate : The framerate of the timecode being parsed. Returns A result tuple with an integer value representing the frame count on success.","ref":"Vtc.Source.Frames.html#frames/2","title":"Vtc.Source.Frames.frames/2","type":"function"},{"doc":"Result type of frames/2 .","ref":"Vtc.Source.Frames.html#t:result/0","title":"Vtc.Source.Frames.result/0","type":"type"},{"doc":"","ref":"Vtc.Source.Frames.html#t:t/0","title":"Vtc.Source.Frames.t/0","type":"type"},{"doc":"Protocol which types can implement to be passed as the main value of Timecode.with_seconds/3 . Implementations Out of the box, this protocol is implemented for the following types: Integer Float Ratio String runtime (&quot;01:00:00.0&quot;) decimal (&quot;3600.0&quot;) Vtc.Source.Seconds.RuntimeStr Vtc.Source.Seconds.PremiereTicks","ref":"Vtc.Source.Seconds.html","title":"Vtc.Source.Seconds","type":"protocol"},{"doc":"Returns the value as a rational, real-world seconds value. Arguments value : The source value. rate : The framerate of the timecode being parsed. Returns A result tuple with a rational representation of the seconds value using Ratio on success.","ref":"Vtc.Source.Seconds.html#seconds/2","title":"Vtc.Source.Seconds.seconds/2","type":"function"},{"doc":"Result type of seconds/2 .","ref":"Vtc.Source.Seconds.html#t:result/0","title":"Vtc.Source.Seconds.result/0","type":"type"},{"doc":"","ref":"Vtc.Source.Seconds.html#t:t/0","title":"Vtc.Source.Seconds.t/0","type":"type"},{"doc":"Defines a composite type for storing rational values as dual int64s. These values are cast to %Ratio{} structs for use in application code, provided by the Ratio library. The composite type is defined as follows: CREATE TYPE public.rational as ( numerator bigint, denominator bigint ) Rational values can be cast in SQL expressions like so: SELECT (1, 2)::rational Field migrations You can create a field as a rational during a migration like so: create table ( &quot;rationals&quot; ) do add ( :a , PgRational . type ( ) ) add ( :b , PgRational . type ( ) ) end Schema fields Then in your schema module: defmodule MyApp.Rationals do @moduledoc false use Ecto.Schema alias Vtc.Ecto.Postgres.PgRational @type t ( ) :: % __MODULE__ { a : Ratio . t ( ) , b : Ratio . t ( ) } schema &quot;rationals_01&quot; do field ( :a , PgRational ) field ( :b , PgRational ) end ... notice that the schema field type is PgRational , but the type-spec field uses Ratio.t() , the type that our DB fields will be deserialized into. Changesets With the above setup, changesets should just work: def changeset ( schema , attrs ) do schema |&gt; Changeset . cast ( attrs , [ :a , :b ] ) |&gt; Changeset . validate_required ( [ :a , :b ] ) end Rational values can be cast from the following values in changesets: %Ratio{} structs. [numerator, denominator] integer arrays. Useful for non-text JSON values that can be set in a single field. Strings formatted as 'numerator/denominator' . Useful for casting from a JSON string.","ref":"Vtc.Ecto.Postgres.PgRational.html","title":"Vtc.Ecto.Postgres.PgRational","type":"module"},{"doc":"Serialize Ratio for use in a query fragment. The fragment must explicitly cast the value to a ::rational type. Examples alias Ecto.Query require Ecto.Query rational = Ratio . new ( 1 , 2 ) rational_sql = PgRational . dump! ( rational ) Query . from ( f in fragment ( &quot;SELECT ?::rational as r&quot; , ^ rational_sql ) , select : f . r )","ref":"Vtc.Ecto.Postgres.PgRational.html#dump!/1","title":"Vtc.Ecto.Postgres.PgRational.dump!/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.embed_as/1 .","ref":"Vtc.Ecto.Postgres.PgRational.html#embed_as/1","title":"Vtc.Ecto.Postgres.PgRational.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2 .","ref":"Vtc.Ecto.Postgres.PgRational.html#equal?/2","title":"Vtc.Ecto.Postgres.PgRational.equal?/2","type":"function"},{"doc":"The database type for PgRational . Can be used in migrations as the fields type.","ref":"Vtc.Ecto.Postgres.PgRational.html#type/0","title":"Vtc.Ecto.Postgres.PgRational.type/0","type":"function"},{"doc":"Type of the raw composite value that will be sent to / received from the database.","ref":"Vtc.Ecto.Postgres.PgRational.html#t:db_record/0","title":"Vtc.Ecto.Postgres.PgRational.db_record/0","type":"type"},{"doc":"Migrations for adding rational types, functions and constraints to a Postgres database.","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html","title":"Vtc.Ecto.Postgres.PgRational.Migrations","type":"module"},{"doc":"Adds raw SQL queries to a migration for creating the database types, associated functions, casts, operators, and operator families. Safe to run multiple times when new functionality is added in updates to this library. Existing values will be skipped. Types Created Calling this macro creates the following type definitions: CREATE TYPE public.rational AS ( numerator bigint, denominator bigint ); ## Examples defmodule MyMigration do use Ecto.Migration alias Vtc.Ecto.Postgres.PgRational require PgRational.Migrations def change do PgRational.Migrations . create_all ( ) end end","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_all/0","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_all/0","type":"function"},{"doc":"Creates basic constraints for a PgRational database field. Constraints created: {field_name}_denominator_positive : Checks that the denominator of the field is positive. Examples create table ( &quot;rationals&quot; , primary_key : false ) do add ( :id , :uuid , primary_key : true , null : false ) add ( :a , PgRational . type ( ) ) add ( :b , PgRational . type ( ) ) end PgRational . migration_add_field_constraints ( :rationals , :a ) PgRational . migration_add_field_constraints ( :rationals , :b )","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_field_constraints/2","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_field_constraints/2","type":"function"},{"doc":"Adds rational composite type.","ref":"Vtc.Ecto.Postgres.PgRational.Migrations.html#create_type/0","title":"Vtc.Ecto.Postgres.PgRational.Migrations.create_type/0","type":"function"},{"doc":"StreamData generators for use in tests that involve custom Ecto types. For use in property tests. This module is only available in :test and :dev envs.","ref":"Vtc.TestUtls.StreamDataVtc.html","title":"Vtc.TestUtls.StreamDataVtc","type":"module"},{"doc":"Yields Vtc.Framerates, always yields true-frame or NTSC; never a mixture of the two. Options type : The ntsc value all framerates should be generated with. Can be any of the following: :whole : All yielded framerates will be non-ntsc, whole-frame rates. Ex: 24/1 fps. :fractional : All yielded framerates will be a random non-drop rate. :non_drop : All yielded framerates will be NTSC, non-drop values. :drop : All yielded framerates will be NTSC, drop-frame values. A list of the above options may be passed and each value yielded from this generator will pick randomly from them. Defaults to [:whole, :fractional, :non_drop, :drop] Examples property &quot;prop test&quot; do check all ( framerate &lt;- StreamDataVtc . framerate ( ) ) do ... end end","ref":"Vtc.TestUtls.StreamDataVtc.html#framerate/1","title":"Vtc.TestUtls.StreamDataVtc.framerate/1","type":"function"},{"doc":"Yields rational values as %Ratio{} structs. Options numerator : A static value to use for the numerator of all genrated rationals. Default: nil. denominator : A static value to use for the denominator of all genrated rationals. Default: nil. positive? : If true, only positive values (greater than 0) are generated. Default: false . Examples property &quot;prop test&quot; do check all ( fraction &lt;- StreamDataVtc . rational ( ) ) do ... end end","ref":"Vtc.TestUtls.StreamDataVtc.html#rational/1","title":"Vtc.TestUtls.StreamDataVtc.rational/1","type":"function"},{"doc":"Yields Vtc.Timecode values, always yields true-frame or NTSC; never a mixture of the two. Options non_negative? : Will only return values greater than or equal to 00:00:00:00 . rate : A framerate to use for this test. If one is not provided, a random one will be used. rate_opts : Opts that should be passed to framerate/1 when generating the framerate. Has no effect if rate is set. Examples property &quot;returns input of negate/1&quot; do check all ( positive &lt;- StreamDataVtc . timecode ( non_negative? : true ) ) do negative = Timecode . minus ( positive ) assert Timecode . abs ( positive ) == Timecode . abs ( negative ) end end","ref":"Vtc.TestUtls.StreamDataVtc.html#timecode/1","title":"Vtc.TestUtls.StreamDataVtc.timecode/1","type":"function"},{"doc":"Describes the opts that can be passed to framerate/1 .","ref":"Vtc.TestUtls.StreamDataVtc.html#t:rate_opts/0","title":"Vtc.TestUtls.StreamDataVtc.rate_opts/0","type":"type"},{"doc":"Exception returned when a framerate cannot be parsed. Struct Fields reason : The reason the error occurred. Failure Reasons The following values can appear in the :reason fields: :bad_drop_rate : Returned when the playback speed of a framerate with an ntsc value of :drop is not divisible by 3000/1001 (29.97), for more on why drop-frame framerates must be a multiple of 29.97, see: https://www.davidheidelberger.com/2010/06/10/drop-frame-timecode/ :invalid_ntsc : Returned when the ntsc value is not one of the allowed atom values. :unrecognized_format : Returned when a string value is not a recognized format. :imprecise - Returned when a float was passed with an NTSC value of nil. Without the ability to round to the nearest valid NTSC value, floats are not precise enough to build an arbitrary framerate.","ref":"Vtc.Framerate.ParseError.html","title":"Vtc.Framerate.ParseError","type":"exception"},{"doc":"Returns a message for the error reason.","ref":"Vtc.Framerate.ParseError.html#message/1","title":"Vtc.Framerate.ParseError.message/1","type":"function"},{"doc":"Type of ParseError","ref":"Vtc.Framerate.ParseError.html#t:t/0","title":"Vtc.Framerate.ParseError.t/0","type":"type"},{"doc":"Exception returned when there is an error parsing a Timecode value. Struct Fields reason : The reason the error occurred. Failure Reasons The following values can appear in the :reason fields: :unrecognized_format : Returned when a string value is not a recognized timecode, runtime, etc. format. :bad_drop_frames : The field value cannot exist in properly formatted drop-frame timecode.","ref":"Vtc.Timecode.ParseError.html","title":"Vtc.Timecode.ParseError","type":"exception"},{"doc":"Returns a message for the error reason.","ref":"Vtc.Timecode.ParseError.html#message/1","title":"Vtc.Timecode.ParseError.message/1","type":"function"},{"doc":"Type of Timecode.ParseError .","ref":"Vtc.Timecode.ParseError.html#t:t/0","title":"Vtc.Timecode.ParseError.t/0","type":"type"},{"doc":"A SMPTE Timecode Library for Elixir","ref":"readme.html","title":"vtc-ex","type":"extras"},{"doc":"A small preview of what Vtc has to offer. Note that printing statements like inspect/1 have been elided from the examples below. Vtc can parse a number of different formats, from timecodes, to frame counts, to film length measured in feet and frames: iex&gt; Timecode . with_seconds! ( 1.5 , Rates . f23_98 ( ) ) &quot;&lt;00:05:23:04 &lt;23.98 NTSC&gt;&gt;&quot; iex&gt; tc = Timecode . with_frames! ( &quot;17:23:13:02&quot; , Rates . f23_98 ( ) ) &quot;&lt;17:23:00:02 &lt;23.98 NTSC&gt;&gt;&quot; Once in a Timecode struct, you convert to any of the supported formats: iex&gt; Timecode . frames ( tc ) 1501922 iex&gt; Timecode . feet_and_frames ( tc ) &quot;&lt;93889+10 :ff35mm_4perf&gt;&quot; Comparisons and kernel sorting are supported, with many helper functions for specific comparisons: iex&gt; Timecode . compare ( tc , &quot;02:00:00:00&quot; ) :gt iex&gt; Timecode . gt? ( tc , &quot;02:00:00:00&quot; ) true iex&gt; tc_01 = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; tc_02 = Timecode . with_frames! ( &quot;02:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; data_01 = %{ id : 2 , tc : tc_01 } iex&gt; data_02 = %{ id : 1 , tc : tc_02 } iex&gt; [ data_02 , data_01 ] |&gt; Enum . sort_by ( &amp; &amp;1 . tc , Timecode ) |&gt; inspect ( ) &quot;[%{id: 2, tc: &lt;01:00:00:00 &lt;23.98 NTSC&gt;&gt;}, %{id: 1, tc: &lt;02:00:00:00 &lt;23.98 NTSC&gt;&gt;}]&quot; All sensible arithmetic operations are provided, such as addition, subtraction, and multiplication: iex&gt; tc = Timecode . add ( tc , &quot;01:00:00:00&quot; ) &quot;&lt;18:23:13:02 &lt;23.98 NTSC&gt;&gt;&quot; You can even use native operators within special eval/2 blocks: iex&gt; Timecode . eval at : 23.98 do iex&gt; tc + &quot;00:30:00:00&quot; * 2 - &quot;00:15:00:00&quot; iex&gt; end &quot;&lt;19:08:13:02 &lt;23.98 NTSC&gt;&gt;&quot; Ranges let you operate on in/out points, such as finding the overlapping area between two ranges: iex&gt; a_in = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; a = Range . new! ( a_in , &quot;02:00:00:00&quot; ) &quot;&lt;01:00:00:00 - 02:00:00:00 :exclusive &lt;23.98 NTSC&gt;&gt;&quot; iex&gt; b_in = Timecode . with_frames! ( &quot;01:45:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Range . new! ( b_in , &quot;02:30:00:00&quot; ) &quot;&lt;01:45:00:00 - 02:30:00:00 :exclusive &lt;23.98 NTSC&gt;&gt;&quot; iex&gt; Range . intersection! ( a , b ) &quot;&lt;01:45:00:00 - 02:00:00:00 :exclusive &lt;23.98 NTSC&gt;&gt;&quot;","ref":"readme.html#demo","title":"vtc-ex - Demo","type":"extras"},{"doc":"Check out the Quickstart Guide for a more in depth walkthrough of what Vtc can do, or dive straight into the API reference .","ref":"readme.html#further-reading","title":"vtc-ex - Further Reading","type":"extras"},{"doc":"Offer a comprehensive set of tools for parsing, manipulating and rendering timecode with all it's quirks and incarnations. Define an intuitive, idiomatic Elixir API. Do all calculations in Rational representation, so there is both no drift or rounding errors when manipulating NTSC timecode, and we can represent time as finely as possible rather than being limited to the granularity of frame numbers. Be approachable for newcomers to the timecode problem space. Each function and concept in the API reference includes a primer on what it is and where it is used in Film and Television workflow. Offer a flexible set of tools that support both rigorous, production-quality code and quick scratch scripts.","ref":"readme.html#goals","title":"vtc-ex - Goals","type":"extras"},{"doc":"SMPTE Conventions: [X] NTSC [X] Drop-Frame [ ] Interlaced timecode Timecode Representations: [X] Timecode | '01:00:00:00' [X] Frames | 86400 [X] Seconds | 3600.0 [X] Runtime | '01:00:00.0' [X] Rational | 18018/5 [X] Feet+Frames | '5400+00' [X] 35mm, 4-perf [ ] 35mm, 3-perf [X] 35mm, 2-perf [X] 16mm [X] Premiere Ticks | 15240960000000 Operations: [X] Comparisons (==, &lt;, &lt;=, &gt;, &gt;=) [X] Add [X] Subtract [X] Scale (multiply and divide) [X] Divmod [X] Modulo [X] Negative [X] Absolute [X] Rebase (recalculate frame count at new framerate) [X] Native Operator Evaluation Flexible Parsing: [X] Partial timecodes | '1:12' [X] Partial runtimes | '1.5' [X] Negative string values | '-1:12', '-3+00' [X] Poorly formatted tc | '1:13:4' [X] Built-in consts for common framerates. [X] Configurable rounding options. [X] Support for standard library sorting behavior. [X] Range type for working with and comparing frame ranges. [X] Overlap between ranges [X] Distance between ranges [X] Inclusive and exclusive ranges [X] Postgres Composite Types with Ecto and Postgrex: Rational[X] [ ] Native comparison operators [ ] Native arithmatic operators [ ] Native indexing support Framerate[ ] Timecode[ ] [ ] Native comparison operators [ ] Native arithmatic operators [ ] Native indexing Support [ ] Native inspection functions Range [ ] Native indexing support [ ] Native inspection functions","ref":"readme.html#features","title":"vtc-ex - Features","type":"extras"},{"doc":"Drop-frame calculations adapted from David Heidelberger's blog . 35mm, 2perf and 16mm format support based on Jamie Hardt's work for vtc-rs . Logo made by Freepik from www.flaticon.com .","ref":"readme.html#attributions","title":"vtc-ex - Attributions","type":"extras"},{"doc":"If available in Hex , the package can be installed by adding vtc to your list of dependencies in mix.exs : def deps do [ { :vtc , &quot;~&gt; 0.10&quot; } ] end","ref":"readme.html#installation","title":"vtc-ex - Installation","type":"extras"},{"doc":"Let's take a little peek at what Vtc can do, for you! Note that printing calls like inspect/1 have been elided from these examples. These are the three main modules that make up the Vtc API: alias Vtc.Framerate alias Vtc.Rates alias Vtc.Timecode Let's start with a 23.98 NTSC timecode. We use the with_frames constructor here since timecode is really a human-readable way to represent frame count. The Vtc.Rates module defines a number of Vtc.Framerate values found in the wild. Most common, by far, is 23.98 NTSC , which is shorthand for video footage running at 24000/1001 frames-per-second. iex&gt; tc = Timecode . with_frames! ( &quot;17:23:13:02&quot; , Rates . f23_98 ( ) ) &quot;&lt;17:23:00:02 &lt;23.98 NTSC&gt;&gt;&quot; Once we have a Vtc.Timecode struct, we can render all sorts of commonly used timecode representations, like timecode itself.","ref":"quickstart.html","title":"Quickstart","type":"extras"},{"doc":"timecode/2 iex&gt; Timecode . timecode ( tc ) &quot;17:23:00:02&quot; frames/2 iex&gt; Timecode . frames ( tc ) 1501922 seconds iex&gt; tc . seconds &quot;Ratio.new(751711961, 12000)&quot; runtime/2 iex&gt; Timecode . runtime ( tc , 3 ) &quot;17:24:15.676&quot; premiere_ticks/2 iex&gt; Timecode . premiere_ticks ( tc ) 15915544300656000 physical film length in feet_and_frames/2 iex&gt; Timecode . feet_and_frames ( tc ) &quot;&lt;93889+10 :ff35mm_4perf&gt;&quot;","ref":"quickstart.html#unit-conversions","title":"Quickstart - Unit Conversions","type":"extras"},{"doc":"ntsc iex&gt; tc . rate . ntsc :non_drop playback speed iex&gt; tc . rate . playback &quot;Ratio.new(24000, 1001)&quot; timebase/1 logical speed iex&gt; Framerate . timebase ( tc . rate ) 24 .","ref":"quickstart.html#framerate-information","title":"Quickstart - Framerate Information","type":"extras"},{"doc":"Parsing is flexible, we can pass in partial or maformed timecode. In Vtc , there are only two ways to parse timecode, either with Timecode.with_frames/2 for formats that represnet a discrete frame count, or Timecode.with_seconds/2 for formats that represent a number of real-world, elapsed seconds were those frames to be played back at the timecode's rate.","ref":"quickstart.html#parsing","title":"Quickstart - Parsing","type":"extras"},{"doc":"Frames Formats timecode iex&gt; Timecode . with_frames! ( &quot;3:12&quot; , Rates . f23_98 ( ) ) &quot;&lt;03:00:00:12 &lt;23.98 NTSC&gt;&gt;&quot; malformed timecode iex&gt; Timecode . with_frames! ( &quot;3:12&quot; , Rates . f23_98 ( ) ) &quot;&lt;03:00:00:12 &lt;23.98 NTSC&gt;&gt;&quot; frame count iex&gt; Timecode . with_frames! ( 24 , Rates . f23_98 ( ) ) &quot;&lt;00:00:01:00 &lt;23.98 NTSC&gt;&gt;&quot; physical film length in feet+frames iex&gt; Timecode . with_frames! ( &quot;1+08&quot; , Rates . f23_98 ( ) ) &quot;&lt;00:00:01:00 &lt;23.98 NTSC&gt;&gt;&quot; Seconds Formats seconds iex&gt; Timecode . with_seconds! ( 1.5 , Rates . f23_98 ( ) ) &quot;&lt;00:05:23:04 &lt;23.98 NTSC&gt;&gt;&quot; runtime iex&gt; Timecode . with_seconds! ( &quot;00:05:23.5&quot; , Rates . f23_98 ( ) ) &quot;&lt;00:05:23:04 &lt;23.98 NTSC&gt;&gt;&quot; malformed runtime iex&gt; Timecode . with_seconds! ( &quot;5:23.5&quot; , Rates . f23_98 ( ) ) &quot;&lt;00:05:23:04 &lt;23.98 NTSC&gt;&gt;&quot; premiere ticks iex&gt; input = % PremiereTicks { in : 254_016_000_000 } iex&gt; Timecode . with_seconds! ( input , Rates . f23_98 ( ) ) &quot;&lt;00:00:01:00 &lt;23.98 NTSC&gt;&gt;&quot;","ref":"quickstart.html#examples","title":"Quickstart - Examples","type":"extras"},{"doc":"By default, feet+frames is interpreted as 35mm, 4perf film. You can use the FeetAndFrames struct to parse other film formats. 16mm feet + frames iex&gt; alias Vtc.Source.Frames.FeetAndFrames iex&gt; iex&gt; { :ok , feet_and_frames } = FeetAndFrames . from_string ( &quot;5400+00&quot; , film_format : :ff16mm ) iex&gt; iex&gt; Timecode . with_frames ( feet_and_frames , Rates . f23_98 ( ) ) &quot;{:ok, &lt;01:15:00:00 &lt;23.98 NTSC&gt;&gt;}&quot;","ref":"quickstart.html#other-film-formats","title":"Quickstart - Other film formats","type":"extras"},{"doc":". add/3 iex&gt; a = Timecode . with_frames! ( &quot;18:23:13:02&quot; , Rates . f23_98 ( ) ) iex&gt; b = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; tc = Timecode . add ( a , b ) &quot;&lt;18:23:13:02 &lt;23.98 NTSC&gt;&gt;&quot; add/3 with string iex&gt; Timecode . add ( tc , &quot;00:10:00:00&quot; ) &quot;&lt;18:33:13:02 &lt;23.98 NTSC&gt;&gt;&quot; add/3 with ints means adding frames iex&gt; Timecode . add ( tc , 38 ) &quot;&lt;18:33:14:16 &lt;23.98 NTSC&gt;&gt;&quot; sub/3 iex&gt; Timecode . sub ( tc , &quot;01:00:00:00&quot; ) &quot;&lt;17:33:14:16 &lt;23.98 NTSC&gt;&gt;&quot; . minus/1 iex&gt; Timecode . minus ( tc ) &quot;&lt;-17:33:14:16 &lt;23.98 NTSC&gt;&gt;&quot; abs/1 iex&gt; Timecode . abs ( tc ) &quot;&lt;17:33:14:16 &lt;23.98 NTSC&gt;&gt;&quot; mult/3 iex&gt; Timecode . mult ( tc , 2 ) &quot;&lt;35:06:29:08 &lt;23.98 NTSC&gt;&gt;&quot; div/3 iex&gt; Timecode . div ( tc , 2 ) &quot;&lt;17:33:14:16 &lt;23.98 NTSC&gt;&gt;&quot; divrem/3 iex&gt; { dividend , remainder } = Timecode . divrem ( tc , 3 ) iex&gt; { dividend , remainder } &quot;{&lt;05:51:04:21 &lt;23.98 NTSC&gt;&gt;, &lt;00:00:00:01 &lt;23.98 NTSC&gt;&gt;}&quot;","ref":"quickstart.html#arithmetic","title":"Quickstart - Arithmetic","type":"extras"},{"doc":"Special Timecode.eval do blocks let us use native operators. eval/2 iex&gt; require Timecode iex&gt; iex&gt; a = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Timecode . with_frames! ( &quot;00:30:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; c = Timecode . with_frames! ( &quot;00:15:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; Timecode . eval do iex&gt; a + b * 2 - c iex&gt; end &quot;&lt;01:45:00:00 &lt;23.98 NTSC&gt;&gt;&quot; Or even do some quick scratch calculations in a given framerate: scratch calculation iex&gt; Timecode . eval at : 23.98 do iex&gt; &quot;01:00:00:00&quot; + &quot;00:30:00:00&quot; * 2 - &quot;00:15:00:00&quot; iex&gt; end &quot;&lt;01:45:00:00 &lt;23.98 NTSC&gt;&gt;&quot;","ref":"quickstart.html#eval","title":"Quickstart - Eval","type":"extras"},{"doc":"We can make dropframe timecode for 29.97 or 59.94 using one of the pre-set framerates. drop-frame iex&gt; Timecode . with_frames! ( 15_000 , Rates . f29_97_df ( ) ) &quot;&lt;00:08:20;18 &lt;29.97 NTSC DF&gt;&gt;&quot; We can make new timecodes with arbitrary framerates if we want. non-ntsc iex&gt; Timecode . with_frames! ( &quot;01:00:00:00&quot; , Framerate . new! ( 240 , nil ) ) &quot;&lt;01:00:00:00 &lt;240.0 fps&gt;&gt;&quot; Using :non_drop indicates this is an NTSC timecode, and will convert whole-number timebases to the correct speed. non-drop coersion iex&gt; Timecode . with_frames! ( &quot;01:00:00:00&quot; , Framerate . new! ( 48 , :non_drop ) ) &quot;&lt;01:00:00:00 &lt;47.95 NTSC&gt;&gt;&quot; We can also rebase the frames using a new framerate! rebase iex&gt; Timecode . rebase ( tc , Rates . f23_98 ( ) ) &quot;&lt;02:00:00:00 &lt;23.98 NTSC&gt;&gt;&quot;","ref":"quickstart.html#framerates","title":"Quickstart - Framerates","type":"extras"},{"doc":"It's easy to compare two timecodes. compare/2 iex&gt; a = Timecode . with_frames! ( &quot;02:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; b = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; Timecode . compare ( a , b ) :lt There a host of other specific comparison functions like eq?/2 , gt?/2 that return booleans. Specific comparison iex&gt; Timecode . lt? ( a , b ) true Like arithmetic, we can compare directly with a timecode string: compare/2 with string iex&gt; Timecode . compare ( a , &quot;00:59:00:00&quot; ) :gt Sorting is suported through the compare/2 function. sort through Timecode iex&gt; tc_01 = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; tc_02 = Timecode . with_frames! ( &quot;02:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; data_01 = %{ id : 2 , tc : tc_01 } iex&gt; data_02 = %{ id : 1 , tc : tc_02 } iex&gt; iex&gt; Enum . sort_by ( [ data_02 , data_01 ] , &amp; &amp;1 . tc , Timecode ) &quot;[%{id: 2, tc: &lt;01:00:00:00 &lt;23.98 NTSC&gt;&gt;}, %{id: 1, tc: &lt;02:00:00:00 &lt;23.98 NTSC&gt;&gt;}]&quot;","ref":"quickstart.html#comparisons-and-sorting","title":"Quickstart - Comparisons and Sorting","type":"extras"},{"doc":"Range helps with common operations using in/out points. Let's set two of those up. new/3 iex&gt; a_in = Timecode . with_frames! ( &quot;01:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; a_out = Timecode . with_frames! ( &quot;02:00:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; a = Range . new! ( a_in , a_out ) &quot;&lt;01:00:00:00 - 02:00:00:00 :exclusive &lt;23.98 NTSC&gt;&gt;&quot; By default, ranges are exclusive , meaning the out point represents the boundary where the clip ends, not the final frame that is part of the video clip. This way will be familiar to Premiere and Final Cut editors. But fear not, our Avid bretheren, inclusive out points like you are used to are available as well! Just like addition, we can write a bare timecode string as the out value if we want. new/3 with string iex&gt; b_in = Timecode . with_frames! ( &quot;01:45:00:00&quot; , Rates . f23_98 ( ) ) iex&gt; iex&gt; b = Range . new! ( b_in , &quot;02:30:00:00&quot; ) &quot;&lt;01:45:00:00 - 02:30:00:00 :exclusive &lt;23.98 NTSC&gt;&gt;&quot; We can get the duration of a range. duration/1 iex&gt; Range . duration ( b ) iex&gt; &quot;&lt;00:45:00:00 &lt;23.98 NTSC&gt;&gt;&quot; ... see if a specific timecode is in a range: contains?/2 iex&gt; Range . contains? ( b , &quot;02:00:00:00&quot; ) iex&gt; true ... or see if it overlaps with another range. overlaps?/2 iex&gt; Range . overlaps? ( a , b ) iex&gt; true We can even get the overlapping area as its own range! intersection/2 iex&gt; Range . intersection! ( a , b ) &quot;&lt;01:45:00:00 - 02:00:00:00 :exclusive &lt;23.98 NTSC&gt;&gt;&quot;","ref":"quickstart.html#ranges","title":"Quickstart - Ranges","type":"extras"},{"doc":"To include Postgres types with Ecto. Add the following into you applications configuration file: config :vtc , env : config_env ( ) , include_postgres_types? : true","ref":"quickstart.html#postgres-types","title":"Quickstart - Postgres Types","type":"extras"},{"doc":"But first: what is timecode? If you're already familiar with timecode, it's history, and it's flavors, feel free to skip this section.","ref":"history.html","title":"Timecode: A History","type":"extras"},{"doc":"Back in the days of film, a running strip of numbers ran along the edge of the film stock to uniquely identify each frame, called keycode Keycode was essential to the film editing process. The raw negative of a film is irreplaceable: you loose quality each time you make a copy. Editing film is necessarily a destructive process , and often required multiple iterations. It would be just a tad nerve-wracking to take a pair of scissors and some glue to the one-of-a-kind film reels straight out of the camera on set, then running it over and over through a flatbed. To avoid potential disaster, editors made their cut of the film using copies of the raw negative, called a work print , allowing the editor to work without fear of sinking a project from slicing, dicing, and wearing at the film. When the edit was complete, it was necessary to know exactly where the edits had been made, so it could be recreated with the raw negative for finishing. A cut list would be written out, with the exact reels and keycodes for every cut, and would be used to make an exact duplicate of the editor's work print with the mint condition raw negative. In video and digital filmmaking, the same approach is used. Massive RAW files from a RED, ARRI, Sony, or other cinema camera are rendered down to more manageable files an Editor's machine won't choke on. Once the edit is complete, the raw files are re-assembled using a digital cutlist on a powerful machine for finishing out the film. In film, we referenced keycode to know exactly what frame was being displayed on screen at any given time. In digital video, we reference the timecode of a given frame, as defined by the SMPTE Timecode standard.","ref":"history.html#how-we-got-here","title":"Timecode: A History - How we got here","type":"extras"},{"doc":"For a technical deep-dive into the many flavors of timecode, check out Frame.io's excellent blogpost on the subject.","ref":"history.html#further-reading","title":"Timecode: A History - Further Reading","type":"extras"},{"doc":"To understand timecode, first we need to understand the difference between framerate, the rate at which a piece of media is actually yielding frames, and timebase, the rate at which we pretend that media is yielding frames when rendering a SMPTE timecode value. Timecode does not -- counterintuitively -- represent the TIME of a frame. Instead, it is a human-digestable INDEX of that frame in the sequence of all frames that make up a video clip, just like keycode before it. It's fields are NOT hours, minutes, seconds, and milliseconds , as you might expect from a time-based format; they are &quot;hours&quot;, &quot;minutes&quot;, &quot;seconds&quot;, and frames (more on the airquotes later). Timecode is more UUID than timestamp.","ref":"framerate_vs_timebase.html","title":"NTSC: Framerate vs Timebase","type":"extras"},{"doc":"For true-frame video -- that is, video where frames never cross the boundary of a given second -- this distinction doesn't matter. When recording at 24.0fps true, the 23rd frame recorded is 00:00:00:23 and the 24th frame recorded is 00:00:01:00 , SMTPE timecode, which lines up with 00:00:01.0 in real-workd hours, minutes, and seconds. Here is the catch -- because there is a catch -- the vast majority of video these days are not recorded in mathmatically convenient framerates. They are recorded at framerates defined by the SMPTE NTSC standard. You can read a deep-dive on that standard here , but the long and short of it is that cinema video is almost always recorded rates commonly referred to as 23.98 , 29.97 , 59.84 , etc. that are fractionally slower than their 24.0 , 30.0 , 60.0 , etc. counterparts. When trying to figure out how to map NTSC frames to a frame-specific timestamp, attempting to conform to the real world becomes difficult. the 24th frame of 23.98, NTSC timecode actually occurs at 00:00:01.001 . If we want a discreet 'frames' place, do we then need to drop frames from some seconds to keep them in-line with a real world clock? Unsuprisingly, some timecode displays do exactly that. NTSC drop-frame timecode takes this approach, and is a nightmare to work with outside the very specific use case of measuring the length of an edit. Thankfully, drop-frame conventions are out of favor these days, and only defined for 29.97 and 59.94 framerates -- the framerates that were used for anologue video and older broadcast television.","ref":"framerate_vs_timebase.html#not-fitting-neatly-into-seconds","title":"NTSC: Framerate vs Timebase - (Not) fitting neatly into seconds","type":"extras"},{"doc":"NTSC non-drop timecode is the favored convention today. Non-drop timecode, as the name suggests, does not drop frames to keep it's &quot;timestamp&quot; in sync with the real-world clock. Instead, it chooses to beleive a convenient lie that all 24 frames in a &quot;second&quot; actually fit in that second, and renders timecode accordingly, with each &quot;second&quot; starting at frame 00 and ending at frame 23 . Drift from the real-world clock is taken as a necessary sin in exchange for not having to manage drop frames. 01:00:00:00 in 23.98 NTSC, non-drop timecode represents 01:00:03.6 in real-world hours, minutes, and seconds.","ref":"framerate_vs_timebase.html#seconds-aren-t-seconds","title":"NTSC: Framerate vs Timebase - &quot;Seconds&quot; aren't Seconds","type":"extras"},{"doc":"Vtc calles the true, real-world framerate of the media -- in this example 24000/1001 -- the playback rate of the timecode. The rate at which timecode is calculated, -- in this example 24/1 -- is called the timebase . But wait -- why are we using fractions all of a sudden? That's because the common way we refer to NTSC frameares -- i.e 23.98 NTSC -- is actually rounded shorthand for it's actual specification: 24000/1001 . We will examine the inherently rational nature of timecode calculations in the next section.","ref":"framerate_vs_timebase.html#vtc-terminology","title":"NTSC: Framerate vs Timebase - Vtc Terminology","type":"extras"},{"doc":"Vtc uses rational (fraction) values to represent both timecode and framerate. Why? Rational values are not oft used in computer science, and less efficient than finding a way to represent your value as either a float or an integer scalar. Video media programs have employed a variety of strategies to numerically representing framerate and timecode -- that is to say frame identifiers -- with varying success. In this document, we will lay out some of the historical approaches, and then examine the reasoning behind Vtc's solution.","ref":"the_rational_rationale.html","title":"The Rational Rationale","type":"extras"},{"doc":"First, a brief distillation of Vtc's goals: Lossless casting in and out of timecode strings No rounding errors when adding or subtracting, or multiplying timecode values Math and comparisons must be frame-accurate in mixed rate contexts Comparisons between timecodes should be based on the real-world time a frame was recorded assuming jam-sync .","ref":"the_rational_rationale.html#requirements","title":"The Rational Rationale - Requirements","type":"extras"},{"doc":"23.98 NTSC timecode is specifified as running at 24000/1001 frames per second, with timecode caculated AS IF it were running at 24fps . 24000/1001 has the unfortunate propery of being an irrational number. It's digits ride off into the sunset, never terminating: iex&gt; 24_000 / 1001 23.976023976023978 This unfortunate mathematical reality has a number of unfortunate knock-on effects when attempting to model frame-accurate timecode calculations.","ref":"the_rational_rationale.html#ntsc-and-digital-computing","title":"The Rational Rationale - NTSC and Digital Computing","type":"extras"},{"doc":"If you look up the NTSC spec, you may notice that it ACTUALLY defines 23.98 NTSC with floats: 24000.0/1001.0 . So what gives? Why do we need more accuracy than the way video equipment represents its frame identifiers internally? When a camera or single-rate video editor is is producing frame timecodes, it is doing so from a frame number. Because those frame numbers are being generated sequentially, and ALWAYS in the context of a uniform frame rate, we can essentially ignore the small amount of real-world jitter that a video stream contains, and there will never be enough precision loss that rounding to the nearest frame will be wrong. But when trying to do theoretical calculation between in and out points, like when manipulating and EDL that dense data becomes sparse data, and we need to make sure we are doing our math in a way that does not lose a frame to precision issues, that can't misplace a frame when doing math between frames as points .","ref":"the_rational_rationale.html#but-wait","title":"The Rational Rationale - But wait...","type":"extras"},{"doc":"Let's review how programs have historically attempted to grapple with timecode, and how they fail to meet the requirements above. Frame integer : One common approach to tacking timecode is to represent it as a frame number with 0 standing for 00:00:00:00 and 24 standing for 00:00:01:00 (at 23.98 ). The problem with this approach is that in mixed-rate scenarios, these values cannot be easily sorted by the real-world time that the frame was captured, and therefore are not suited to tasks like syncing multicams, or audio where cameras were recording at multiple framerates. For instance, 00:00:00:23 @ 23.98 and 00:00:00:46 @ 47.95 both represent the same real-world time, but would be represented as 23 and 46 respectively. Seconds float : Another common technique is to do all arithmatic in floating point, and represent the timecode as a seconds value. So 00:00:02:00 would be represented as 48.0 frames / (24000.0/1001.0) fps = 2.002 seconds . Most cameras calculate a their Timecode values this way, and the official NTSC specification uses floats to define 24000.0/1001.0 as the 23.98 NTSC framerate. This works great when you are calculating each timecode frame-by-frame. You take each frame numebr and after 23.976023976023978 seconds, you record the frame buffer and generate a new Timecode for that frame's index. No frames are skipped. Likewise, when casting in and out of timecode strings, there isn't enough precision loss for errors to occur. But when you start adding timecodes together... errors can happen. Let's take a timecode of 00:00:00:23 . If we convert it to seconds, we get: iex&gt; seconds = 23 / ( 24_000 / 1001 ) 0.9592916666666667 Now let's say we have five events that we want to get the total length of, each is 23 seconds long. At the end we cast back to frames so we can construct the timecode: iex&gt; ( seconds + seconds + seconds + seconds + seconds ) * ( 24_000.0 / 1001.0 ) 115.00000000000001 We are just a little bit off. For this particular calculation, rounding gets us back to the correct answer, but over the course of thousands of operations, say for summing the duration of all events in an EDL, it adds up. We cannot cast back to frames to make this correction after every operation in mixed frame contexts either. Floats can also cause comparison errors in mixed framerate contexts. Let's imagine we have one camera on set recording at 119.88 NTSC , and one camera recording at 23.98 NTSC . For both cameras, 23:13:13:00 should equal the same real-world time. But if we convert the timecode stamps to real-world seconds as a float by calculating the frame number and dividing by the frame rate: iex&gt; # 23.98 NTSC iex&gt; 2_006_232 / ( 24_000 / 1001 ) 83676.593 iex&gt; # 23.98 NTSC iex&gt; 10_031_160 / ( 120_000 / 1001 ) 83676.59300000001 Although these values SHOULD be equivalent, they are not. For applications that require frame-accurate timeode comparisons, this appriach will not work, something video editors have historically struggled with. Avid, for instance, disallowed mixed-rate timelines for years, focing users to transcode their media to a uniform rate before they could edit it together. Quantized time Some programs attempt to define a minimum discreet time unit, such as a millisecond, nanosecond, etc, and capture timecode as a scalar value of that unit. Premiere, for instance, represents timecode as a &quot;tick&quot;, which it defines as a 254_016_000_000th of a second. Video clip in, out, and duration values are all converted to a tick integer value. This approach can cause rounding issues when generating EDLs, FCP7 XMLs, AAFs and others. Although in recent times the program has gotten much bettern, Premiere originally had a number of off-by-one errors when it first started supporting professional video workflows via interchange formats, ESPECIALLY when the framerate of the media did not match the framerate of the edit sequence. Again, 1 frame in 23.98 is equal to 0.04170833333333333 seconds. The digits value is not easily representable as a discreet time value, and choosing an arbitraty quanta for time means that the true frame time of a video clip of an arbitrary framearate may not always neatly line up with the boundaries of your unit, cuasing gradual drift when you start doing math.","ref":"the_rational_rationale.html#historical-approaches","title":"The Rational Rationale - Historical Approaches","type":"extras"},{"doc":"Lastly, it is important to note that Vtc does NOT strive to be as efficient as possible. Timecode manipulation -- when needed -- is not an operation that most programe needs to be done on the scale of millions of times per second, and will certainly not account for the majority of calculations that a program will be doing at any given step. Therefore, we believe that the loss in efficiency is worth the gain in accuracy and ease of use that Rational values provide. However, it is good to keep in mind that each time a rational value is produces the operation will involve multiple sub-operations. In the case of addition: three multiplication, then recursive division to simplify the fraction.","ref":"the_rational_rationale.html#on-efficiency","title":"The Rational Rationale - On Efficiency","type":"extras"},{"doc":"Vtc chose rational representation of timecode as a frame-accurate way to deal with timecode values in mixed rate contexts. In short, we PUT OFF the step of casting to a discreet value like a float, tick, millisecond, etc until AFTER we are done making calculations, convserving -- as accurately as possible -- a true, frame-accurate time.","ref":"the_rational_rationale.html#conclusion","title":"The Rational Rationale - Conclusion","type":"extras"},{"doc":"NOTE: This document is under developement.","ref":"contributing.html","title":"Contributing","type":"extras"},{"doc":"Please make pull requests based off the dev branch into the dev branch. The release CI pipleine adds additional files to the main branch whenever a PR is merged.","ref":"contributing.html#making-a-pr","title":"Contributing - Making a PR","type":"extras"},{"doc":"To run all linters that will be run in CI: make line You'll need to install the following non-elixir programs: misspell","ref":"contributing.html#running-lints","title":"Contributing - Running lints","type":"extras"},{"doc":"To run all tests with coverage reports: make test Vtc offers optional Postgres extensions. If you do not have a Posgres instanve running locally you can skip those tests like so: mix test -- exclude :postgres Or: mix test -- exclude :ecto","ref":"contributing.html#running-tests","title":"Contributing - Running tests","type":"extras"}]